Index: java/main/src/main/java/com/framsticks/gui/FrameJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 97)
@@ -0,0 +1,148 @@
+package com.framsticks.gui;
+
+import java.awt.BorderLayout;
+import java.awt.Container;
+import java.awt.event.WindowAdapter;
+import java.awt.event.WindowEvent;
+import java.util.concurrent.atomic.AtomicBoolean;
+
+import javax.swing.JFrame;
+import javax.swing.UIManager;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+public abstract class FrameJoinable extends SwingJoinable<JFrame> implements ExceptionResultHandler {
+	private static final Logger log =
+		Logger.getLogger(FrameJoinable.class);
+
+	protected String title;
+
+	protected final StatusBar statusBar;
+
+
+	/**
+	 *
+	 */
+	public FrameJoinable() {
+		statusBar = new StatusBar();
+	}
+
+	public void setTitle(String title) {
+		this.title = title;
+		if (hasSwing()) {
+			getSwing().setTitle(title);
+		}
+	}
+
+	/**
+	 * @return the statusBar
+	 */
+	public StatusBar getStatusBar() {
+		return statusBar;
+	}
+
+	@Override
+	public String getName() {
+		return title;
+	}
+
+	private final static AtomicBoolean sentGuiInitialization = new AtomicBoolean(false);
+
+
+	@Override
+	protected void joinableStart() {
+
+		if (sentGuiInitialization.compareAndSet(false, true)) {
+			dispatch(new RunAt<FrameJoinable>(ThrowExceptionHandler.getInstance()) {
+				@Override
+				protected void runAt() {
+					try {
+						boolean found = false;
+						// for (LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
+						//	log.info("look and feel available: " + info.getName());
+						//	if ("Nimbus".equals(info.getName())) {
+						//		UIManager.setLookAndFeel(info.getClassName());
+						//		found = true;
+						//		break;
+						//	}
+						// }
+						if (!found) {
+							UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
+						}
+						JFrame.setDefaultLookAndFeelDecorated(true);
+					} catch (Exception e) {
+						throw new FramsticksException().msg("failed to initialize Look&Feel").cause(e);
+					}
+				}
+			});
+		}
+
+		super.joinableStart();
+		dispatch(new RunAt<FrameJoinable>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				getSwing().setVisible(true);
+			}
+		});
+
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		super.joinableInterrupt();
+
+		dispatch(new RunAt<Frame>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				finish();
+			}
+		});
+
+	}
+
+	@Override
+	protected void joinableFinish() {
+		super.joinableFinish();
+		log.debug("disposing frame " + this);
+		getSwing().dispose();
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		super.joinableJoin();
+
+	}
+
+	@Override
+	protected void initializeGui() {
+		setSwing(new JFrame(title));
+		statusBar.initializeGui();
+
+		Container contentPane = getSwing().getContentPane();
+		contentPane.setLayout(new BorderLayout());
+		contentPane.add(statusBar.getSwing(), BorderLayout.SOUTH);
+
+		getSwing().setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
+
+		getSwing().addWindowListener(new WindowAdapter() {
+			@Override
+			public void windowClosing(WindowEvent e) {
+				log.info("received closing");
+				interrupt();
+			}
+		});
+
+
+	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		statusBar.handle(exception);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/Gui.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 97)
@@ -45,8 +45,14 @@
 
 	public static Control createComponentForText(PrimitiveParam<?> valueParam) {
-		if (valueParam.getMin(Object.class) != null) {
-			return new TextAreaControl(valueParam);
+		if (valueParam.getMax(Object.class) != null) {
+			return new TextFieldControl(valueParam);
 		}
-		return new TextFieldControl(valueParam);
+		return new TextAreaControl(valueParam);
+
+
+		// if (valueParam.getMin(Object.class) != null) {
+		// 	return new TextAreaControl(valueParam);
+		// }
+		// return new TextFieldControl(valueParam);
 	}
 
@@ -64,5 +70,5 @@
 				return new SliderControl(decimalParam);
 			}
-			return createComponentForText(decimalParam);
+			return new TextFieldControl(decimalParam);
 		}
 		if (param instanceof FloatParam) {
@@ -71,23 +77,23 @@
 				return new SliderControl(floatParam);
 			}
-			return createComponentForText(floatParam);
+			return new TextFieldControl(floatParam);
 		}
 		if (param instanceof StringParam) {
-			return createComponentForText((StringParam)param);
+			return createComponentForText((StringParam) param);
 		}
 		if (param instanceof ProcedureParam) {
-			return new ProcedureControl((ProcedureParam)param);
+			return new ProcedureControl((ProcedureParam) param);
 		}
 		if (param instanceof BinaryParam) {
-			return createComponentForText((BinaryParam)param);
+			return new TextFieldControl((BinaryParam) param);
 		}
 		if (param instanceof ColorParam) {
-			return createComponentForText((ColorParam) param);
+			return new TextFieldControl((ColorParam) param);
 		}
 		if (param instanceof UniversalParam) {
-			return new TextAreaControl((UniversalParam)param);
+			return new TextAreaControl((UniversalParam) param);
 		}
 		if (param instanceof EventParam) {
-			return new EventControl((EventParam)param);
+			return new EventControl((EventParam) param);
 		}
 		return null;
Index: java/main/src/main/java/com/framsticks/gui/MainFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 97)
@@ -1,16 +1,17 @@
 package com.framsticks.gui;
 
-import com.framsticks.gui.windows.console.ConsoleFrame;
-import com.framsticks.util.swing.MenuConstructor;
-import org.apache.log4j.Logger;
-
-import javax.swing.*;
-import javax.swing.border.TitledBorder;
-import java.awt.*;
 import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
 import java.awt.event.KeyEvent;
 import java.awt.event.WindowAdapter;
 import java.awt.event.WindowEvent;
+
+import javax.swing.AbstractAction;
+import javax.swing.JButton;
+import javax.swing.KeyStroke;
+import javax.swing.WindowConstants;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.util.swing.MenuConstructor;
 
 /**
@@ -28,5 +29,6 @@
 	 */
 	public MainFrame(final Browser browser) {
-		super("framsticks", browser);
+		super(browser);
+		setTitle("framsticks");
 		log.debug("creating main frame");
 
@@ -35,6 +37,6 @@
 
 	@Override
-	public void configure() {
-		super.configure();
+	protected void initializeGui() {
+		super.initializeGui();
 
 		new MenuConstructor(fileMenu)
@@ -42,5 +44,5 @@
 				@Override
 				public void actionPerformed(ActionEvent actionEvent) {
-					showConsoleFrame();
+					// showConsoleFrame();
 				}
 			})
@@ -145,86 +147,75 @@
 	// }
 
-	public void setSimulationRunning(final boolean run) {
-		assert isActive();
-		/*
-		remoteInstance.invokeLater(new Runnable() {
-			@Override
-			public void run() {
-				remoteInstance.setRunning(run);
-			}
-		});
-		*/
-	}
-
-	/**
-	 * Creates panel with start, step, stop buttons.
-	 */
-	@Override
-	protected JPanel createLeftTopPanel() {
-		assert isActive();
-		Dimension buttonDimension = new Dimension(45, 45);
-
-		JPanel panel = new JPanel();
-
-		stop = new JButton(ImageProvider.loadImage(ImageProvider.SIM_STOP));
-		stop.addActionListener(new ActionListener() {
-
-			public void actionPerformed(ActionEvent e) {
-				setSimulationRunning(false);
-			}
-
-		});
-
-		stop.setPreferredSize(buttonDimension);
-		stop.setToolTipText("Simulation Stop");
-		stop.setEnabled(false);
-
-		step = new JButton(ImageProvider.loadImage(ImageProvider.SIM_STEP));
-		/*
-		step.addActionListener(new ActionListener() {
-
-			public void actionPerformed(ActionEvent e) {
-				connection.send(new CallQuery().setMethod("step").setPath("/simulator"));
-			}
-
-		});
-		*/
-
-		step.setPreferredSize(buttonDimension);
-		step.setToolTipText("Simulation Step");
-
-		start = new JButton(ImageProvider.loadImage(ImageProvider.SIM_START));
-		start.addActionListener(new ActionListener() {
-
-			public void actionPerformed(ActionEvent e) {
-				setSimulationRunning(true);
-			}
-
-		});
-
-		start.setPreferredSize(buttonDimension);
-		start.setToolTipText("Start Simulation");
-
-		JPanel buttonPanel = new JPanel();
-		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.LINE_AXIS));
-		buttonPanel.add(Box.createHorizontalStrut(5));
-		buttonPanel.add(stop);
-		buttonPanel.add(Box.createHorizontalStrut(10));
-		buttonPanel.add(step);
-		buttonPanel.add(Box.createHorizontalStrut(10));
-		buttonPanel.add(start);
-		buttonPanel.add(Box.createHorizontalStrut(5));
-
-		buttonPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory
-				.createRaisedBevelBorder(), "Simulation Control",
-				TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION
-				));
-
-		panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
-		panel.add(Box.createHorizontalGlue());
-		panel.add(buttonPanel);
-		panel.add(Box.createHorizontalGlue());
-		return panel;
-	}
+
+	// /**
+	//  * Creates panel with start, step, stop buttons.
+	//  */
+	// @Override
+	// protected JPanel createLeftTopPanel() {
+	// 	assert isActive();
+	// 	Dimension buttonDimension = new Dimension(45, 45);
+
+	// 	JPanel panel = new JPanel();
+
+	// 	stop = new JButton(ImageProvider.loadImage(ImageProvider.SIM_STOP));
+	// 	stop.addActionListener(new ActionListener() {
+
+	// 		public void actionPerformed(ActionEvent e) {
+	// 			setSimulationRunning(false);
+	// 		}
+
+	// 	});
+
+	// 	stop.setPreferredSize(buttonDimension);
+	// 	stop.setToolTipText("Simulation Stop");
+	// 	stop.setEnabled(false);
+
+	// 	step = new JButton(ImageProvider.loadImage(ImageProvider.SIM_STEP));
+	// 	/*
+	// 	step.addActionListener(new ActionListener() {
+
+	// 		public void actionPerformed(ActionEvent e) {
+	// 			connection.send(new CallQuery().setMethod("step").setPath("/simulator"));
+	// 		}
+
+	// 	});
+	// 	*/
+
+	// 	step.setPreferredSize(buttonDimension);
+	// 	step.setToolTipText("Simulation Step");
+
+	// 	start = new JButton(ImageProvider.loadImage(ImageProvider.SIM_START));
+	// 	start.addActionListener(new ActionListener() {
+
+	// 		public void actionPerformed(ActionEvent e) {
+	// 			setSimulationRunning(true);
+	// 		}
+
+	// 	});
+
+	// 	start.setPreferredSize(buttonDimension);
+	// 	start.setToolTipText("Start Simulation");
+
+	// 	JPanel buttonPanel = new JPanel();
+	// 	buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.LINE_AXIS));
+	// 	buttonPanel.add(Box.createHorizontalStrut(5));
+	// 	buttonPanel.add(stop);
+	// 	buttonPanel.add(Box.createHorizontalStrut(10));
+	// 	buttonPanel.add(step);
+	// 	buttonPanel.add(Box.createHorizontalStrut(10));
+	// 	buttonPanel.add(start);
+	// 	buttonPanel.add(Box.createHorizontalStrut(5));
+
+	// 	buttonPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory
+	// 			.createRaisedBevelBorder(), "Simulation Control",
+	// 			TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION
+	// 			));
+
+	// 	panel.setLayout(new BoxLayout(panel, BoxLayout.LINE_AXIS));
+	// 	panel.add(Box.createHorizontalGlue());
+	// 	panel.add(buttonPanel);
+	// 	panel.add(Box.createHorizontalGlue());
+	// 	return panel;
+	// }
 
 	/**
@@ -233,14 +224,14 @@
 	private void setFrameProperties() {
 		assert isActive();
-		swing.setMinimumSize(swing.getPreferredSize());
-		swing.setSize(swing.getPreferredSize());
-		swing.setMaximumSize(screenDimension);
-		swing.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
-
-		swing.setIconImage(ImageProvider.loadImage(ImageProvider.LOGO)
+		getSwing().setMinimumSize(getSwing().getPreferredSize());
+		getSwing().setSize(getSwing().getPreferredSize());
+		getSwing().setMaximumSize(screenDimension);
+		getSwing().setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
+
+		getSwing().setIconImage(ImageProvider.loadImage(ImageProvider.LOGO)
 				.getImage());
 
 
-		swing.addWindowListener(new WindowAdapter() {
+		getSwing().addWindowListener(new WindowAdapter() {
 			public void windowClosing(WindowEvent e) {
 				assert isActive();
@@ -251,18 +242,18 @@
 				*/
 				onWindowClosing();
-				swing.dispose();
+				getSwing().dispose();
 			}
 		});
 	}
 
-	public ConsoleFrame showConsoleFrame() {
-		assert isActive();
-		/*
-		ConsoleFrame consoleFrame = new ConsoleFrame(connection);
-		consoleFrame.show(MainFrame.this);
-		return consoleFrame;
-		*/
-		return null;
-	}
+	// public ConsoleFrame showConsoleFrame() {
+	// 	assert isActive();
+	// 	/*
+	// 	ConsoleFrame consoleFrame = new ConsoleFrame(connection);
+	// 	consoleFrame.show(MainFrame.this);
+	// 	return consoleFrame;
+	// 	*/
+	// 	return null;
+	// }
 
 	/**
@@ -271,8 +262,7 @@
 	private void disconnect() {
 		assert isActive();
-		//remoteInstance.disconnect();
 		browser.clear();
 		onWindowClosing();
-		statusBar.setText("You are disconnected");
+		// statusBar.setText("You are disconnected");
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 97)
@@ -39,4 +39,6 @@
 
 		applyButton = new JButton("Apply");
+		applyButton.setName("apply");
+
 		applyButton.addActionListener(new ActionListener() {
 			public void actionPerformed(ActionEvent e) {
Index: java/main/src/main/java/com/framsticks/gui/MultiPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 97)
@@ -24,5 +24,5 @@
 		for (Panel p : panels) {
 			assert p.getClassName().equals(getClassName());
-			assert p.getInstanceAtFrame() == getInstanceAtFrame();
+			assert p.getTreeAtFrame() == getTreeAtFrame();
 			tabbedPane.add(p.getTitle(), p);
 		}
Index: java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 97)
@@ -17,4 +17,6 @@
 import java.util.Map;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
+
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.RunAt;
 
@@ -70,5 +72,5 @@
 	public void pullValuesFromLocalToUser(AccessInterface access) {
 		assert currentTreeNode != null;
-		assert currentTreeNode.path.getInstance().isActive();
+		assert currentTreeNode.path.getTree().isActive();
 		log.debug("refreshing components");
 
@@ -78,7 +80,7 @@
 		}
 
-		frame.dispatch(new RunAt<Frame>() {
+		frame.dispatch(new RunAt<Frame>(frame) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				if (currentTreeNode.localChanges != null) {
 					for (Map.Entry<ValueControl, Object> e : currentTreeNode.localChanges.entrySet()) {
@@ -111,4 +113,9 @@
 	}
 
+	@Override
+	public void handle(FramsticksException exception) {
+		frame.handle(exception);
+	}
+
 	// public void updateValue() {
 	//	//assert panel.getFrame().isActive();
Index: java/main/src/main/java/com/framsticks/gui/Panel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 97)
@@ -15,10 +15,10 @@
 
 	public static class Parameters {
-		public final InstanceAtFrame instanceAtFrame;
+		public final TreeAtFrame treeAtFrame;
 		public final CompositeParam param;
 		public final FramsClass framsClass;
 
-		public Parameters(InstanceAtFrame instanceAtFrame, CompositeParam param, FramsClass framsClass) {
-			this.instanceAtFrame = instanceAtFrame;
+		public Parameters(TreeAtFrame treeAtFrame, CompositeParam param, FramsClass framsClass) {
+			this.treeAtFrame = treeAtFrame;
 			this.param = param;
 			this.framsClass = framsClass;
@@ -29,5 +29,5 @@
 
 	protected TreeNode currentTreeNode;
-	protected final InstanceAtFrame instanceAtFrame;
+	protected final TreeAtFrame treeAtFrame;
 	protected final Frame frame;
 	protected final String className;
@@ -37,6 +37,6 @@
 
 	public Panel(Parameters parameters) {
-		this.instanceAtFrame = parameters.instanceAtFrame;
-		this.frame = parameters.instanceAtFrame.getFrame();
+		this.treeAtFrame = parameters.treeAtFrame;
+		this.frame = parameters.treeAtFrame.getFrame();
 		this.framsClass = parameters.framsClass;
 		this.param = parameters.param;
@@ -57,6 +57,6 @@
 	}
 
-	public final InstanceAtFrame getInstanceAtFrame() {
-		return instanceAtFrame;
+	public final TreeAtFrame getTreeAtFrame() {
+		return treeAtFrame;
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/PopupMenuEntryProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/PopupMenuEntryProvider.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/PopupMenuEntryProvider.java	(revision 97)
@@ -0,0 +1,9 @@
+package com.framsticks.gui;
+
+import javax.swing.JPopupMenu;
+
+import com.framsticks.core.Path;
+
+public interface PopupMenuEntryProvider {
+	public void provide(JPopupMenu menu, Path path);
+}
Index: java/main/src/main/java/com/framsticks/gui/StatusBar.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 97)
@@ -0,0 +1,72 @@
+package com.framsticks.gui;
+
+
+import java.awt.BorderLayout;
+import java.awt.Dimension;
+// import java.awt.Dimension;
+
+import javax.swing.JPanel;
+import javax.swing.JTextField;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.gui.controls.Control;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.RunAt;
+
+public class StatusBar implements ExceptionResultHandler, Dispatcher<StatusBar> {
+	private static final Logger log = Logger.getLogger(StatusBar.class);
+
+	protected JTextField statusBar;
+	protected JPanel swing;
+
+	/**
+	 *
+	 */
+	public StatusBar() {
+	}
+
+	@Override
+	public void handle(final FramsticksException exception) {
+		dispatch(new RunAt<StatusBar>(this) {
+
+			@Override
+			protected void runAt() {
+				log.error("error: " + exception);
+				statusBar.setText(exception.getShortMessage(new StringBuilder()).toString());
+			}
+		});
+	}
+
+	public void initializeGui() {
+		statusBar = new JTextField();
+		statusBar.setEditable(false);
+
+		swing = new JPanel();
+		swing.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
+
+		swing.setLayout(new BorderLayout());
+		swing.add(statusBar, BorderLayout.CENTER);
+		// swing.add(statusBar);
+	}
+
+	@Override
+	public boolean isActive() {
+		return SwingDispatcher.getInstance().isActive();
+	}
+
+	@Override
+	public void dispatch(RunAt<? extends StatusBar> runnable) {
+		SwingDispatcher.getInstance().dispatch(runnable);
+	}
+
+	/**
+	 * @return the swing
+	 */
+	public JPanel getSwing() {
+		return swing;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 96)
+++ java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 97)
@@ -3,4 +3,5 @@
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Task;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
 import javax.swing.*;
@@ -21,7 +22,7 @@
 
 	public SwingDispatcher() {
-		dispatch(new RunAt<C>() {
+		dispatch(new RunAt<C>(ThrowExceptionHandler.getInstance()) {
 			@Override
-			public void run() {
+			protected void runAt() {
 				Thread.currentThread().setName("gui");
 			}
Index: java/main/src/main/java/com/framsticks/gui/SwingJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/SwingJoinable.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/SwingJoinable.java	(revision 97)
@@ -0,0 +1,73 @@
+package com.framsticks.gui;
+
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+public abstract class SwingJoinable<Swing> extends AbstractJoinable implements Dispatcher<SwingJoinable<Swing>> {
+
+	private Swing swing;
+
+	/**
+	 * @return the swing
+	 */
+	public Swing getSwing() {
+		if (swing == null) {
+			throw new FramsticksException().msg("swing has not yet been initialized").arg("in", this);
+		}
+		return swing;
+	}
+
+	public boolean hasSwing() {
+		return swing != null;
+	}
+
+	/**
+	 * @param swing the swing to set
+	 */
+	protected void setSwing(Swing swing) {
+		this.swing = swing;
+	}
+
+
+	protected abstract void initializeGui();
+
+	@Override
+	protected void joinableStart() {
+		dispatch(new RunAt<SwingJoinable<Swing>>(ThrowExceptionHandler.getInstance()) {
+			@Override
+			protected void runAt() {
+				initializeGui();
+			}
+		});
+	}
+
+	@Override
+	public boolean isActive() {
+		return SwingDispatcher.instance.isActive();
+	}
+
+	@Override
+	public void dispatch(RunAt<? extends SwingJoinable<Swing>> runnable) {
+		SwingDispatcher.getInstance().dispatch(runnable);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 97)
+++ java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 97)
@@ -0,0 +1,179 @@
+package com.framsticks.gui;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.Tree;
+import com.framsticks.core.TreeListener;
+import com.framsticks.core.ListChange;
+import com.framsticks.core.Node;
+import com.framsticks.core.Path;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+
+import java.util.*;
+
+import javax.swing.tree.TreePath;
+import com.framsticks.util.dispatching.RunAt;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class TreeAtFrame implements TreeListener {
+
+	private static final Logger log = Logger.getLogger(TreeAtFrame.class);
+
+	protected final Frame frame;
+	protected final Tree tree;
+	protected final Map<String, Panel> knownPanels = new HashMap<String, Panel>();
+	protected TreeNode rootTreeNode;
+
+	public TreeAtFrame(Tree tree, Frame frame) {
+		this.frame = frame;
+		this.tree = tree;
+	}
+
+	public Frame getFrame() {
+		return frame;
+	}
+
+	/**
+	 * @return the tree
+	 */
+	public Tree getTree() {
+		return tree;
+	}
+
+	public void registerPanel(Panel panel) {
+	}
+
+	public Panel findPanel(String accessId) {
+		assert frame.isActive();
+		return (knownPanels.containsKey(accessId) ? knownPanels.get(accessId) : null);
+	}
+
+	public final String getName() {
+		return tree.getName();
+	}
+
+	public Panel preparePanel(CompositeParam param, FramsClass framsClass) {
+		assert frame.isActive();
+		Panel panel = preparePanelImpl(param, framsClass);
+		assert panel != null;
+		String accessId = param.computeAccessId();
+		panel.uniqueName = accessId + "@" + tree.getName();
+		knownPanels.put(accessId, panel);
+		frame.cardPanel.add(panel, panel.uniqueName);
+		log.debug("prepared panel for " + panel);
+		return panel;
+	}
+
+	protected Panel preparePanelImpl(CompositeParam param, FramsClass framsClass) {
+		assert frame.isActive();
+		List<Panel> panels = new ArrayList<Panel>();
+
+		Panel.Parameters parameters = new Panel.Parameters(this, param, framsClass);
+		for (PanelProvider pp : frame.browser.panelProviders) {
+			Panel p = pp.providePanel(parameters);
+			if (p != null) {
+				panels.add(p);
+			}
+		}
+
+		if (panels.isEmpty()) {
+			return new EmptyPanel(parameters);
+		}
+		if (panels.size() == 1) {
+			return panels.get(0);
+		}
+		return new MultiPanel(parameters, panels);
+
+	}
+
+	@Override
+	public void onListChange(Path path, ListChange change) {
+
+	}
+
+	public TreePath getTreePath(Path path, boolean create) {
+		assert frame.isActive();
+		TreeNode t = rootTreeNode;
+		TreePath result = new TreePath(frame.rootNode).pathByAddingChild(rootTreeNode);
+		List<Node> nodes = path.getNodes();
+		Iterator<Node> i = nodes.iterator();
+		i.next();
+		// Node first = i.next();
+
+		// if (!t.path.isResolved()) {
+		//	t.path = new Path(path.getInstance(), nodes, first);
+		// }
+		while (i.hasNext()) {
+			Node n = i.next();
+			TreeNode r = null;
+			for (TreeNode c : t.childrenIterable()) {
+				if (c.param.getId().equals(n.getParam().getId())) {
+					r = c;
+					break;
+				}
+			}
+			if (r == null) {
+				log.debug("missing " + n.getParam().getId() + " in " + t);
+				if (!create) {
+					return result;
+				}
+				Path p = Path.build().tree(path.getTree()).buildUpTo(nodes, n).finish();
+
+
+				log.debug("forced resolution: creating treenode for " + p);
+				TreeNode childNode = new TreeNode(TreeAtFrame.this, p);
+
+				frame.addNode(childNode, t);
+				// frame.treeModel.reload();
+				// t.add(childNode);
+				// frame.treeModel.nodeStructureChanged(t);
+
+				r = childNode;
+			} else {
+				// if (!r.path.isResolved()) {
+				//	r.path = new Path(path.getInstance(), nodes, n);
+				// }
+			}
+			result = result.pathByAddingChild(r);
+			t = r;
+		}
+		return result;
+	}
+
+	@Override
+	public void onFetch(final Path path) {
+		assert tree.isActive();
+		log.trace("fetched " + path);
+
+		frame.dispatch(new RunAt<Frame>(frame) {
+			@Override
+			protected void runAt() {
+
+				TreePath treePath = getTreePath(path, true);
+				assert treePath.getPathCount() == path.size() + 1;
+
+				final TreeNode result = (TreeNode) treePath.getLastPathComponent();
+				// log.trace("found " + result + " == " + path);
+				tree.dispatch(new RunAt<Tree>(frame) {
+					@Override
+					protected void runAt() {
+						result.reactForFetchResult(path, null);
+					}
+				});
+			}
+		});
+	}
+
+	@Override
+	public void onRun(Exception e) {
+
+	}
+
+	@Override
+	public void onStop(Exception e) {
+
+	}
+}
